//var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

const cPrefPrefix = "fireshot.";
const cFirstTimeRun = cPrefPrefix + "firstTimeRunFlag";
const cCurrentVersion = cPrefPrefix + "curVersion";
const cToolbarCreated = cPrefPrefix + "toolbarCreated";
const cWelcomePageURI = "http://screenshot-program.com/fireshot/installed.php?ver=";
const cAboutURI = "http://screenshot-program.com/fireshot/";
const cDemoURI = "http://screenshot-program.com/fireshot/demo.php";
const cSupportURI = "http://screenshot-program.com/sup/frm12.htm";
const cReviewURI = "http://screenshot-program.com/fireshot/review.php";
const cDonateURI = "http://screenshot-program.com/fireshot/donate.php";
const cUpdatedURI = "http://screenshot-program.com/fireshot/updated.php?ver=";
const cUpgradeURI = "http://screenshot-program.com/fireshot/upgrade.php";
const cRegisterURI = "http://screenshot-program.com/fireshot/register.php";
const cUpgradedSuccessfullyURI = "http://screenshot-program.com/fireshot/upgraded.php";

const cActionEdit = 0;
const cActionSave = 1;
const cActionClipboard = 2;
const cActionEMail = 3;
const cActionPaint = 4;
const cActionUpload = 5;
const cActionPrint = 7;

const prefAreaType = cPrefPrefix + "areaType";
const prefActionType = cPrefPrefix + "actionType";
const prefPlaySound = cPrefPrefix + "playSound";
const prefCaptureFlash = cPrefPrefix + "captureFlash";

const prefContextMenu = cPrefPrefix + "contextMenu";
const prefToolsMenu = cPrefPrefix + "toolsMenu";
const prefStatusBar = cPrefPrefix + "statusBar";
const prefNavigationPanel = cPrefPrefix + "navigationPane";

const prefUserAgent = "general.useragent.extra.fireshot";
const prefResizeAction = cPrefPrefix + "resizeAction";
const prefResizeWidth = cPrefPrefix + "resizeWidth";
const prefResizeHeight = cPrefPrefix + "resizeHeight";
const prefResizePercentage = cPrefPrefix + "resizePercentage";
const prefFlashCapDelay                = cPrefPrefix + "flashCapDelay";
const prefIsProMode        = cPrefPrefix + "isProMode";
const prefIsRegistered     = cPrefPrefix + "isRegistered";
const prefCaptureFullMode        = cPrefPrefix + "captureFullMode";

/**
 * myPreferences - a wrapper around nsIPrefService. Provides built in
 *                 exception handling to make preferences access simpler.
 **/
var myPreferences = {
  get mPrefService()
    {
      return Components.classes["@mozilla.org/preferences-service;1"]
                       .getService(Components.interfaces.nsIPrefBranch);
    },

  setBoolPref: function (aPrefName, aPrefValue)
    {
      try
        {
          this.mPrefService.setBoolPref(aPrefName, aPrefValue);
        }
      catch(e)
        {
        }
    },

  getBoolPref: function (aPrefName, aDefVal)
    {
      try
        {
          return this.mPrefService.getBoolPref(aPrefName);
        }
      catch(e)
        {
          return aDefVal != undefined ? aDefVal : null;
        }
      return null;        // quiet warnings
    },

  setUnicharPref: function (aPrefName, aPrefValue)
    {
      try
        {
          var str = Components.classes["@mozilla.org/supports-string;1"]
                              .createInstance(Components.interfaces.nsISupportsString);
          str.data = aPrefValue;
          this.mPrefService.setComplexValue(aPrefName,
                                            Components.interfaces.nsISupportsString, str);
        }
      catch(e)
        {
        }
    },

  copyUnicharPref: function (aPrefName, aDefVal)
    {
      try
        {
          return this.mPrefService.getComplexValue(aPrefName,
                                                   Components.interfaces.nsISupportsString).data;
        }
      catch(e)
        {
          return aDefVal != undefined ? aDefVal : null;
        }
      return null;        // quiet warnings
    },

  setIntPref: function (aPrefName, aPrefValue)
    {
      try
        {
          this.mPrefService.setIntPref(aPrefName, aPrefValue);
        }
      catch(e)
        {
        }
    },

  getIntPref: function (aPrefName, aDefVal)
    {
      try
        {
          return this.mPrefService.getIntPref(aPrefName);
        }
      catch(e)
        {
          return aDefVal != undefined ? aDefVal : null;
        }
      return null;        // quiet warnings
    },

  getLocalizedUnicharPref: function (aPrefName, aDefVal)
    {
      try
        {
          return this.mPrefService.getComplexValue(aPrefName,
                                                   Components.interfaces.nsIPrefLocalizedString).data;
        }
      catch(e)
        {
          return aDefVal != undefined ? aDefVal : null;
        }
      return null;        // quiet warnings
    }
};

var FireShotSettings ={
	restore:function()
	{
	        document.getElementById("area-type").selectedItem =
	                document.getElementById(myPreferences.getLocalizedUnicharPref(prefAreaType, "at-visible"));

	        document.getElementById("action-type").selectedItem =
	                document.getElementById(myPreferences.getLocalizedUnicharPref(prefActionType, "at-edit"));

	        document.getElementById("play-sound").checked =
	                myPreferences.getBoolPref(prefPlaySound, true);

	        document.getElementById("chk-capture-flash").checked =
	                myPreferences.getBoolPref(prefCaptureFlash, true);

	        document.getElementById("integrate-context").checked =
	                myPreferences.getBoolPref(prefContextMenu, true);
					
			document.getElementById("integrate-tools").checked =
	                myPreferences.getBoolPref(prefToolsMenu, true);
					
			document.getElementById("integrate-status").checked =
	                myPreferences.getBoolPref(prefStatusBar, true);
					
			document.getElementById("integrate-navigation").checked =
	                myPreferences.getBoolPref(prefNavigationPanel, true);

	        document.getElementById("resize-action").selectedIndex =
	                myPreferences.getIntPref(prefResizeAction, 0);

	        document.getElementById("resize-input-width").value =
	                myPreferences.getLocalizedUnicharPref(prefResizeWidth, "800");

	        document.getElementById("resize-input-height").value =
	                myPreferences.getLocalizedUnicharPref(prefResizeHeight, "600");

	        document.getElementById("resize-input-percentage").value =
	                myPreferences.getLocalizedUnicharPref(prefResizePercentage, "75");

	        document.getElementById("flashcap-input").value =
	                myPreferences.getIntPref(prefFlashCapDelay, "0");
	},

	store:function()
	{
	        myPreferences.setUnicharPref(prefAreaType, document.getElementById("area-type").selectedItem.id);
	        myPreferences.setUnicharPref(prefActionType, document.getElementById("action-type").selectedItem.id);

	        myPreferences.setBoolPref(prefPlaySound, document.getElementById("play-sound").checked);
	        myPreferences.setBoolPref(prefCaptureFlash, document.getElementById("chk-capture-flash").checked);

	        myPreferences.setBoolPref(prefContextMenu, document.getElementById("integrate-context").checked);
			myPreferences.setBoolPref(prefToolsMenu, document.getElementById("integrate-tools").checked);
			myPreferences.setBoolPref(prefStatusBar, document.getElementById("integrate-status").checked);
			myPreferences.setBoolPref(prefNavigationPanel, document.getElementById("integrate-navigation").checked);

	        myPreferences.setIntPref(prefResizeAction, document.getElementById("resize-action").selectedIndex);

	        myPreferences.setUnicharPref(prefResizeWidth, document.getElementById("resize-input-width").value);
	        myPreferences.setUnicharPref(prefResizeHeight, document.getElementById("resize-input-height").value);
	        myPreferences.setUnicharPref(prefResizePercentage, document.getElementById("resize-input-percentage").value);
	        myPreferences.setIntPref(prefFlashCapDelay, document.getElementById("flashcap-input").value);
	}
}